/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


#define VAR

#include <iostream.h>
#include "list.hxx"
#include "except.hxx"
#include "var.hxx"

void call_throw(int, char*) {
}

int Count = 0 ;

class A ;

ListPtr<A> lp ;

#include "test.hxx"

ListVal<A> lv ;


void main() {

  for (int i = 0; i < 50; i++) {
    A* a = new A ;
    a->i = i ;
    lp.insert(a, 0) ;
  }

  for (i = 0; i < 50; i++) {
    A* a = new A ;
    a->i = i ;
    lv.insert(*a, 0) ;
    delete a ;
  }

  cout << "Taille de la liste Pointeur : " << lp.count() << endl ;
  cout << "Taille de la liste Valeur : " << lv.count() << endl ;
  cout << endl ;

  IterListPtr<A> iter1(lp) ;
  for (; iter1.more(); iter1.next()) {
    cout << iter1.get()->i << ", " ;
  }
  cout << endl ;
  cout << endl ;

  IterListVal<A> iter2(lv) ;
  for (; iter2.more(); iter2.next()) {
    cout << iter2.get().i << ", " ;
  }
  cout << endl ;
  cout << endl ;

  IterListPtr<A> iter3(lp) ;
  i = 0 ;
  while (iter3.more()) {
    if (i % 10 != 0) {
      delete iter3.get() ;
      iter3.remove() ;
    } else {
      iter3.next() ;
    }
    i++ ;
  }

  IterListVal<A> iter4(lv) ;
  i = 0 ;
  while (iter4.more()) {
    if (i % 10 != 0) {
      iter4.remove() ;
    } else {
      iter4.next() ;
    }
    i++ ;
  }

  cout << "Taille de la liste Pointeur : " << lp.count() << endl ;
  cout << "Taille de la liste Valeur : " << lv.count() << endl ;
  cout << endl ;

  for (i = 0; i < lp.count(); i++) {
    cout << lp.get(i)->i << ", " ;
  }
  cout << endl ;

  for (i = 0; i < lv.count(); i++) {
    cout << lv.get(i).i << ", " ;
  }
  cout << endl ;

  int s = lp.count() ;
  for (i = 0; i < s; i++) {
    delete lp.get(0) ;
    lp.remove(0) ;
  }
  cout << endl ;

  s = lv.count() ;
  for (i = 0; i < s; i++) {
    lv.remove(0) ;
  }

  cout << "Taille de la liste Pointeur : " << lp.count() << endl ;
  cout << "Taille de la liste Valeur : " << lv.count() << endl ;
  cout << endl ;


  cout << "Objets restant : " << Count << endl ;
}

  
  
